<template>
  <div class="row mt-4 mb-2">
    <div class="col-lg-12 col-12">
      <div class="card bg-light shadow" v-for="(user, index) in users" :key="index">
        <div class="card-header bg-white">
          <div class="row">
            <div
              class="col-lg-2 col-12 float-left text-blue pt-1 pl-0 mt-1 ml-3"
            >Applicant #{{index+1}}</div>
            <div
              class="col-lg-3 col-12 float-left-lg text-blue pt-1 pl-lg-0"
              v-if="usersList.length > 0"
            >
              <select
                class="form-control form-control-xs select d-inline mr-5"
                @change="changeUser($event, index)"
                v-bind:id="'select'+index"
              >
                <option>Select from my Account</option>
                <option v-for="(v, index) in usersList" v-bind:key="index">
                  <div
                    v-if="v.id===user.id && v.selected"
                    :class="{'d-none': (v.id !== user.id && v.selected) }"
                  >{{v.name}}</div>
                  <div v-if="!v.selected" v-bind:key="index">{{v.name}}</div>
                </option>
              </select>
            </div>
            <div class="col-lg col-12 mt-1 pr-4" v-if="showRemoveButton(index, user.id)">
              <button
                type="button"
                class="btn btn-outline-danger float-right"
                @click="removeApplication(index, user.id)"
              >Remove Applicant</button>
            </div>
          </div>
        </div>
        <div class="card-body info-content">
          <form>
            <div class="row mt-lg-3 mb-lg-3">
              <div class="form-group col-lg text-left">
                <label>First and Middle Name</label>
                <input type="text" class="form-control" v-model="user.name" />
              </div>
              <div class="form-group col-lg text-left">
                <label>Lastname</label>
                <input type="text" class="form-control" v-model="user.lastname" />
              </div>
              <div class="form-group col-lg text-left">
                <label>Nationality(as in passport)</label>
                <select
                  class="form-control form-control-xs select d-inline mr-5"
                  v-model="user.nationality"
                >
                  <option>Select option</option>
                  <option v-for="(n, index) in nationalities" v-bind:key="index">{{n}}</option>
                </select>
              </div>
              <div class="form-group col-lg text-left">
                <label>Birthday</label>
                <input type="text" class="form-control" v-model="user.birthday" />
              </div>
              <div class="form-group col-lg text-left">
                <label>Country of Birth</label>
                <select
                  class="form-control form-control-xs select d-inline mr-5"
                  v-model="user.countryOfBirth"
                >
                  <option>Select option</option>
                  <option v-for="(c, index) in countries" v-bind:key="index">{{c}}</option>
                </select>
              </div>
            </div>
            <div class="row mt-lg-3 mb-lg-3">
              <div class="form-group col-lg text-left">
                <label>Gender</label>
                <select
                  class="form-control form-control-xs select d-inline mr-5"
                  v-model="user.gender"
                >
                  <option>Select option</option>
                  <option v-for="(g, index) in gender" v-bind:key="index">{{g}}</option>
                </select>
              </div>
              <div class="form-group col-lg text-left">
                <label>Passport number</label>
                <input type="text" class="form-control" v-model="user.passport" />
              </div>
              <div class="form-group col-lg text-left">
                <label>Passport issued</label>
                <input type="text" class="form-control" v-model="user.passportIssued" />
              </div>
              <div class="form-group col-lg text-left">
                <label>Passport expiration</label>
                <input type="text" class="form-control" v-model="user.passportExp" />
              </div>
              <div class="col"></div>
            </div>
            <div class="row mt-lg-3 mb-lg-3">
              <div class="form-group col-lg-5 col-sm-6 col-12 text-left">
                <label>Visa Type</label>
                <select
                  class="form-control form-control-xs select d-inline mr-5"
                  v-model="user.visaType"
                >
                  <option>Select option</option>
                  <option v-for="(v, index) in visa" v-bind:key="index">{{v}}</option>
                </select>
              </div>
              <div
                class="form-group col-lg-5 col-sm-6 col-12 text-left d-flex align-items-center pt-lg-4 mt-lg-3"
              >
                <label>
                  Visa cost
                  <b class="text-blue">(USD XXXX) IMPORTANT INFORMATION</b>
                </label>
              </div>
            </div>
          </form>
          <div class="row border-top pt-4" v-if="detectLast(index)">
            <div class="col-12 text-right">
              <button
                class="btn curve text-light p3"
                @click="addApplication(index)"
              >Add new applicant</button>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "BasicApplicant",
  props: {
    usersData: Array
  },
  watch: {
    usersData() {
      this.usersList = [...this.usersData];
      this.usersList.map(e => {
        e.selected = false;
        return e;
      });
    }
  },

  methods: {
    addApplication: function(index) {
      if (this.usersList.length > 0) {
        this.usersList[this.selected].selected = true;
      }
      this.users.push({ ...this.user });
    },
    changeUser: function(event, index) {
      let indexU = event.target.selectedIndex;
      let user = this.usersData
        .map(e => {
          return e.id;
        })
        .indexOf(indexU);
      this.selected = user;
      if (this.users.length > 1) {
        this.users.splice(index, 1);
        this.users.push(this.usersData[user]);
      } else {
        this.users = [];
        this.users[0] = this.usersData[user];
      }
    },
    detectLast: function(index) {
      if (
        this.users.length >= 1 &&
        index === Object.keys(this.users).length - 1
      ) {
        return true;
      }
      return false;
    },
    showRemoveButton: function(index) {
      if (this.users.length >= 2 && this.detectLast(index)) {
        return true;
      }
      return false;
    },
    removeApplication: function(index, user) {
      this.users.splice(index, 1);
      let p = this.usersList
        .map(e => {
          return e.id;
        })
        .indexOf(user);
      if (p != -1) {
        this.usersList[p].selected = false;
      }
    },
  },
  data() {
    return {
      countries: ["Argentina", "USA", "Peru", "Venezuela"],
      gender: ["Female", "Male"],
      last: false,
      nationalities: ["American", "Peruvian", "Venezuelan"],
      visa: [
        "Bussines eVisa -90 days, Multiple Entries",
        "Bussines eVisa -120 days, Multiple Entries"
      ],
      usersList: [],
      user: {
        name: "",
        lastname: "",
        email: "",
        nationality: "",
        birthday: "",
        countryOfBirth: "",
        gender: "",
        passport: "",
        passportExp: "",
        passportIssued: "",
        visaType: ""
      },
      list: [],
      users: [
        {
          ...this.user
        }
      ],
      selected: 0,
      list: []
    };
  }
};
</script>

<style scoped lang="scss">
p {
  margin-top: 0.25em;
  margin-bottom: 0.25em;
  .center {
    margin: auto;
  }
}
</style>
